package xyz.lychee.lagfixer.nms.v1_17_R1;

import com.mojang.authlib.GameProfile;
import com.mojang.authlib.properties.Property;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Iterator;
import java.util.List;
import java.util.Objects;
import java.util.Set;
import java.util.UUID;
import java.util.stream.Stream;
import net.minecraft.server.level.EntityPlayer;
import net.minecraft.world.entity.EntityCreature;
import net.minecraft.world.level.GameRules;
import org.apache.commons.lang.RandomStringUtils;
import org.bukkit.Bukkit;
import org.bukkit.Chunk;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.World;
import org.bukkit.craftbukkit.v1_17_R1.CraftChunk;
import org.bukkit.craftbukkit.v1_17_R1.CraftServer;
import org.bukkit.craftbukkit.v1_17_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_17_R1.entity.CraftCreature;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Item;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Projectile;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.world.EntitiesLoadEvent;
import org.bukkit.event.world.EntitiesUnloadEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.persistence.PersistentDataType;
import org.bukkit.plugin.Plugin;
import xyz.lychee.lagfixer.managers.ModuleManager;
import xyz.lychee.lagfixer.managers.SupportManager;
import xyz.lychee.lagfixer.modules.CustomAiModule;
import xyz.lychee.lagfixer.modules.CustomVehiclesModule;
import xyz.lychee.lagfixer.objects.AbstractSupportNms;

public class SupportNms extends AbstractSupportNms {
   private final int viewDistance = ((CraftServer)Bukkit.getServer()).getHandle().getViewDistance();
   private final int simulationDistance = 0;
   private final GameRules.GameRuleKey<GameRules.GameRuleInt> randomTickSpeed;

   public SupportNms(Plugin plugin) {
      super(plugin);
      this.randomTickSpeed = GameRules.n;
   }

   public int getViewDistance() {
      return ((CraftServer)Bukkit.getServer()).getHandle().getViewDistance();
   }

   public int getViewSimulation() {
      return 0;
   }

   public ItemStack setNBTValue(ItemStack is, String key, String value) {
      ItemMeta meta = is.getItemMeta();
      if (meta != null) {
         meta.getPersistentDataContainer().set(new NamespacedKey(this.getPlugin(), key), PersistentDataType.STRING, value);
         is.setItemMeta(meta);
      }

      return is;
   }

   public boolean hasNBTValue(ItemStack is, String key) {
      ItemMeta meta = is.getItemMeta();
      return meta != null ? meta.getPersistentDataContainer().has(new NamespacedKey(this.getPlugin(), key), PersistentDataType.STRING) : false;
   }

   public String getNBTValue(ItemStack is, String key) {
      ItemMeta meta = is.getItemMeta();
      return meta != null ? (String)meta.getPersistentDataContainer().get(new NamespacedKey(this.getPlugin(), key), PersistentDataType.STRING) : null;
   }

   public ItemStack createSkull(String base64) {
      ItemStack is = new ItemStack(Material.PLAYER_HEAD);
      ItemMeta meta = is.getItemMeta();
      if (meta == null) {
         return is;
      } else {
         GameProfile profile = new GameProfile(UUID.randomUUID(), RandomStringUtils.randomAlphabetic(8));
         profile.getProperties().put("textures", new Property("textures", base64));

         try {
            Method mtd = meta.getClass().getDeclaredMethod("setProfile", GameProfile.class);
            mtd.setAccessible(true);
            mtd.invoke(meta, profile);
         } catch (NoSuchMethodException | InvocationTargetException | IllegalAccessException var6) {
            return is;
         }

         is.setItemMeta(meta);
         return is;
      }
   }

   public void setDefaultDistance() {
      this.setDistance(this.viewDistance, this.simulationDistance);
   }

   public void setRandomTickSpeed(World w, boolean bl) {
      GameRules.GameRuleValue<GameRules.GameRuleInt> handle = ((CraftWorld)w).getHandle().getGameRules().get(this.randomTickSpeed);
      handle.setValue(bl ? "3" : "0");
   }

   public int getTileEntitiesCount(Chunk c) {
      return c.isLoaded() ? ((CraftChunk)c).getHandle().l.size() : 0;
   }

   public int averagePing() {
      List<EntityPlayer> playerList = ((CraftServer)Bukkit.getServer()).getHandle().j;
      return (int)playerList.stream().mapToInt((p) -> {
         return p.e;
      }).average().orElse(0.0);
   }

   public void setSpawnLimits(World w, int monsters, int animals, int water_animals, int water_ambient, int water_underground_creature, int axolotls, int ambient) {
      w.setMonsterSpawnLimit(monsters);
      w.setAnimalSpawnLimit(animals);
      w.setWaterAnimalSpawnLimit(water_animals);
      w.setWaterAmbientSpawnLimit(water_ambient);
      w.setWaterUndergroundCreatureSpawnLimit(water_underground_creature);
      w.setAmbientSpawnLimit(ambient);
   }

   public double getTps(int time) {
      return ((CraftServer)Bukkit.getServer()).getServer().recentTps[time];
   }

   public void setDistance(int view, int simulation) {
      if (view > 0) {
         ((CraftServer)Bukkit.getServer()).getHandle().a(view);
      }

   }

   public void setEntityAi(Entity ent, boolean bl) {
      if (ent instanceof CraftCreature) {
         EntityCreature mob = ((CraftCreature)ent).getHandle();
         if (mob.isNoAI() != bl) {
            return;
         }

         mob.setNoAI(!bl);
         mob.setAggressive(!bl);
         mob.setSilent(!bl);
         mob.collides = !bl;
      }

   }

   @EventHandler(
      priority = EventPriority.HIGHEST
   )
   public void onSpawn(EntitiesLoadEvent e) {
      SupportManager.EXECUTOR.execute(() -> {
         List<Entity> entities = e.getEntities();
         CustomAiModule module1 = (CustomAiModule)ModuleManager.getInstance().get(CustomAiModule.class);
         Stream var10000;
         if (module1 != null && module1.canContinue(e.getWorld()) && module1.isLoaded()) {
            var10000 = entities.stream();
            Objects.requireNonNull(module1);
            var10000.filter(module1::isEnabled).forEach((entx) -> {
               module1.getCustomAi().setCustomAi(entx, false);
            });
         }

         CustomVehiclesModule module2 = (CustomVehiclesModule)ModuleManager.getInstance().get(CustomVehiclesModule.class);
         if (module2 != null && module2.canContinue(e.getWorld()) && module2.isLoaded()) {
            var10000 = entities.stream();
            Objects.requireNonNull(module2);
            var10000.filter(module2::isEnabled).forEach((entx) -> {
               module2.getCustomVehicles().setCustomVehicle(entx);
            });
         }

         SupportManager support = SupportManager.getInstance();
         Set<LivingEntity> creatures = support.getCreatureSet(e.getWorld());
         Set<Item> items = support.getItemSet(e.getWorld());
         Set<Projectile> projectiles = support.getProjectileSet(e.getWorld());
         Iterator var8 = entities.iterator();

         while(var8.hasNext()) {
            Entity ent = (Entity)var8.next();
            if (ent instanceof LivingEntity) {
               creatures.add((LivingEntity)ent);
            } else if (ent instanceof Item) {
               items.add((Item)ent);
            } else if (ent instanceof Projectile) {
               projectiles.add((Projectile)ent);
            }
         }

      });
   }

   @EventHandler(
      priority = EventPriority.HIGHEST
   )
   public void onUnload(EntitiesUnloadEvent e) {
      SupportManager.EXECUTOR.execute(() -> {
         SupportManager support = SupportManager.getInstance();
         Set<LivingEntity> creatures = support.getCreatureSet(e.getWorld());
         Set<Item> items = support.getItemSet(e.getWorld());
         Set<Projectile> projectiles = support.getProjectileSet(e.getWorld());
         Iterator var5 = e.getEntities().iterator();

         while(var5.hasNext()) {
            Entity ent = (Entity)var5.next();
            if (ent instanceof LivingEntity) {
               creatures.remove((LivingEntity)ent);
            } else if (ent instanceof Item) {
               items.remove((Item)ent);
            } else if (ent instanceof Projectile) {
               projectiles.remove((Projectile)ent);
            }
         }

      });
   }
}
